# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]

## [0.6.1] - 2022-06-05
### Changed
- Updated dependencies to resolve their security vulnerabilities

## [0.6.0] - 2021-09-21
### Breaking Changes
- Support changed to TypeDoc versions 0.22.x due to a breaking change in TypeDoc's output folder structure.
### Added
- New option "backgroundColor" to specify the background color of all class diagrams.
### Changed
- Background color of class diagrams defaults to "transparent" to better integrate with TypeDoc's new dark theme.

## [0.5.0] - 2021-08-08
### Breaking Changes
- Support changed to TypeDoc versions >=0.21.0 due to a breaking change in TypeDoc's API.

## [0.4.0] - 2021-05-23
### Breaking Changes
- Moved options to a single option object
  (see: [How to migrate from older versions to 0.4](https://github.com/krisztianb/typedoc-umlclass/blob/master/docs/migration/0.4.md))
### Added
- Automatic detection of CPU count
### Changed
- Updated dependencies
- Default value of option `generatorProcessCount` changed from `1` to number of available CPUs

## [0.3.2] - 2021-01-10
### Added
- Add support for newer TypeDoc versions: 0.20.14 and above (see: https://github.com/TypeStrong/typedoc/pull/1461)
- Add support for older TypeDoc versions: 0.17.x and 0.18.x

## [0.3.1] - 2020-12-22
### Added
- New option to specify the server for remote image URLs

## [0.3.0] - 2020-08-29
### Added
- Support of type parameter default values for template classes
### Changed
- Update to typedoc 0.19.0 and TypeScript 4

## [0.2.2] - 2020-07-25
### Added
- Class template parameters and arguments

## [0.2.1] - 2020-07-05
### Added
- New option to specify the order of class properties/methods
### Changed
- Diagram legends are not generated by default

## [0.2.0] - 2020-06-30
### Added
- New option to specify the number of JAVA/PlantUML processes to spawn
### Changed
- Don't spawn a separate JAVA/PlantUML process for every diagram

## [0.1.7] - 2020-06-26
### Added
- New option to generate a legend for the diagrams
### Fixed
- Double quotes around names of external types
- Wrong visibility of methods
- Class symbol sometimes visible for external types

## [0.1.6] - 2020-06-01
### Added
- Progress bar and option to hide it
- New option to output the generated PlantUML code into files
- New option for vebose output to debug the plugin
### Fixed
- External types without a reflection were not visible in the class diagrams
- Creating empty diagrams that block typedoc from finishing
- Types with complex names could lead to a PlantUML syntax error

## [0.1.5] - 2020-05-24
### Added
- Embed diagrams into HTML output
### Fixed
- Don't encode and decode PlantUML code when generating local image files

## [0.1.4] - 2020-05-19
### Added
- Include method parameters in the class diagram
- New option umlClassDiagramMethodParameterOutput
- CSS class for the HTML section
### Fixed
- Wrong types for attributes and method return values when using complex types

## [0.1.3] - 2020-05-17
### Added
- Include class name in local image filename
### Changed
- Default image format is now SVG
### Fixed
- Malformed local SVG image output

## [0.1.2] - 2020-05-13
### Added
- Faster PlantUML generation with caching

## [0.1.1] - 2020-05-10
### Added
- First version

[Unreleased]: https://github.com/krisztianb/typedoc-umlclass/compare/v0.6.1...HEAD
[0.6.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.6.1
[0.6.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.6.0
[0.5.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.5.0
[0.4.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.4.0
[0.3.2]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.3.2
[0.3.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.3.1
[0.3.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.3.0
[0.2.2]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.2.2
[0.2.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.2.1
[0.2.0]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.2.0
[0.1.7]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.7
[0.1.6]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.6
[0.1.5]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.5
[0.1.4]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.4
[0.1.3]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.3
[0.1.2]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.2
[0.1.1]: https://github.com/krisztianb/typedoc-umlclass/releases/tag/v0.1.1
